#include <vector>

class Document
{
public:
	virtual ~Document() = 0;
}; // Document::~Document() {} in .cpp

class Text : public Document { };
// + classes Picture, Video,...

class DocCreator
{
public:
	virtual Document* create() = 0;
	virtual ~DocCreator() = 0;
}; // DocCreator::~DocCreator() {} in .cpp

class TextCreator : public DocCreator
{
public:
	Document* create() {return new Text();}
};
// + classes PictureCreator, VideoCreator,...

class NewDocManager
{
	DocCreator& m_c;
	std::vector<Document*> m_elems;
public:
	NewDocManager(DocCreator& c) : m_c (c) {}
	~NewDocManager()
	{
		for (size_t i=0; i<m_elems.size(); i++)
		{
			delete m_elems[i];
		}
	}
	Document* newDoc()
	{
		Document* d = m_c.create();
		m_elems.push_back (d);
		return d;
	}
};
