class Point
{
public:
	bool operator == (Point const& p) const
	{
		return equal(p);
	}
	virtual bool equal (Point const& p) const = 0;
	virtual ~Point() {}
};


class Point2D: public Point
{
private:
	int x,y;
public:
	Point2D (int x1, int y1): x(x1), y(y1) {}
	virtual bool equal (Point const& p) const
	{
		Point2D const& that = dynamic_cast<Point2D const&>(p);
		return (x==that.x && y==that.y);
	}
};

class Point3D: public Point
{
private:
	int x,y,z;
public:
	Point3D (int x1, int y1, int z1): x(x1), y(y1), z(z1) {}
	virtual bool equal (Point const& p) const
	{
		Point3D const& that = dynamic_cast<Point3D const&>(p);
		return (x==that.x && y==that.y && z==that.z);
	}
};
