#include "prototype.h"

#include <iostream>
using namespace std;

class Maschine
{
public:
	Maschine () {}
	virtual ~Maschine () {}
	virtual void print() const = 0;
	virtual Maschine * clone() const = 0;
};

class Bohrer : public Maschine
{
public:
	Bohrer () {}
	virtual ~Bohrer() {}
	virtual void print () const
	{
		cout << "bohre, bohre" << endl;
	}
	virtual Maschine * clone() const
	{
		return new Bohrer;
	}
};

class Saege : public Maschine
{
public:
	Saege () {}
	virtual ~Saege() {}
	virtual void print () const
	{
		cout << "saege, saege" << endl;
	}
	virtual Maschine * clone() const
	{
		return new Saege;
	}
};


int main()
{
	PrototypeManager <Maschine> pm;

	pm.insert("saege", Saege());
	pm.insert("bohrer", Bohrer());

	auto_ptr<Maschine> s (pm.create("saege"));
	s->print();

	auto_ptr<Maschine> b (pm.create("bohrer"));
	b->print();
}
