template <typename T>
void Stack<T>::push (T const& elem)
{
	m_elems.push_back(elem);
}

template <typename T>
T Stack<T>::pop ()
{
	if (m_elems.empty()) throw
		std::out_of_range("Stack<>::pop(): cant pop empty stack");
	T ret = m_elems.back();
	m_elems.pop_back();
	return ret;
}

template <typename T>
	template <typename A>
Stack<T>& Stack<T>::operator= (Stack<A> const& op2)
{
	if ((void*)this == (void*)&op2) return *this;

	Stack<A> tmp(op2); // create a copy
	m_elems.clear();
	while (!tmp.empty())
	{
		m_elems.push_front(tmp.pop());
	}

	return *this;
}
